bool P_in_CS = false;
bool Q_in_CS = false;
byte critical = 0;

active proctype P() {
  do
    :: printf("P non-critical actions\n");
       P_in_CS = true;
       !Q_in_CS;
       /* begin critical section */
       critical++;
       printf("P uses shared resourses\n");
       assert (critical < 2);
       critical--;
       /* end critical section */
       P_in_CS = false
  od
}

active proctype Q() {        
  do 
    :: printf("Q non-critical actions\n");
       Q_in_CS = true;
       !P_in_CS;
       /* begin critical section */
       critical++;
       printf("Q uses shared resourses\n");
       assert (critical < 2);
       critical--;
       /* end critical section */
       Q_in_CS = false
  od
}
